Description

History

#1 - 01/09/2020 08:54 PM - Ahmed Bilal

e Done "uncloud api" refactoring which was due for a long time and is the last refactoring beside https://redmine.ungleich.ch/issues/7590.
e Schemas has been greatly simplified (now approaching to beautiful code :) and are now pleasant to work with.

A sample comparison

Before

class BaseSchema:

def

def

def

def

def

def

__init__ (self, data, fields=None):
_ = data # suppress linter warning
self._ _errors = []
if fields is None:

self.fields = []
else:

self.fields = fields

validation (self) :
pass

is_valid(self) :

for field in self.fields:
field.is_valid()
self.add_field_errors (field)

for parent in self._ class__._ bases__:

try:
parent.validation (self)
except AttributeError:
pass
if not self._ errors:
self.validation ()

if self._ _errors:
return False
return True

get_errors (self):
return {"message": self.__errors}

add_field_errors(self, field: Field):
self.__errors += field.get_errors()

add_error (self, error):
self.__errors.append(error)

class OTPSchema (BaseSchema) :

def

__init_ (self, data: dict, fields=None) :
self.name = Field("name", str, data.get ("name",

KeyError))

self.realm = Field("realm", str, data.get ("realm", KeyError))
https://redmine.ungleich.ch/issues/7590

self.token = Field("token", str, data.get ("token",
_fields =
if fields:

_fields += fields

super () .__init__ (data=data,

[self.name, self.realm, self.token]

fields=_fields)

def validation(self):
if (check_otp(self.name.value, self.realm.value,
self.add_error ("Wrong Credentials")

After

class BaseSchema:
def _ _init__ (self):
self.fields = [getattr(self, field) for field in dir(self)
def validation(self):
# custom validation is optional
return True
def is_valid(self):
for field in self.fields:
field.is_valid()

for parent in self._ class__._ bases__:
parent.validation (self)

self.validation ()

for field in self.fields:

setattr(self, field.name, field.value)

class OTPSchema (BaseSchema) :

def __init_ (self, data: dict):
self.name = Field('name', str, get(data, 'name'))
self.realm = Field('realm', str, get(data, 'realm'))
self.token = Field('token', str, get(data, 'token'))
super () .__init__ ()

def validation(self):
if check_otp(self.name.value, self.realm.value,
raise ValidationException ('Wrong Credentials')

#2 - 01/09/2020 08:56 PM - Ahmed Bilal

To see merge request https://code.ungleich.ch/uncloud/uncloud/merge_requests/1

#3 - 02/26/2020 12:07 PM - Ahmed Bilal

- Status changed from New to Closed
self.token.value) !=

self.token.value)

KeyError))

200) :

if isinstance (getattr(self,

!= 200:

field), Field)]
